function apperr=OMP_Shist(D,X,L); 
%=============================================
% Sparse coding of a group of signals based on a given 
% dictionary and specified number of atoms to use. 
% input arguments: 
%       D - the dictionary (its columns MUST be normalized).
%       X - the signals to represent
%       L - the max. number of coefficients for each signal.
% output arguments: 
%       apperr - residual norm for each sparsity level S = 1:L
%=============================================
[n,P]=size(X);
[n,K]=size(D);

apperr = zeros(L,P);
for k=1:1:P,
    a=[];
    x=X(:,k);
    normx = norm(x);
    residual=x;
    indx=zeros(L,1);
    for j=1:1:L,
        proj=D'*residual;
        [maxVal,pos]=max(abs(proj));
        pos=pos(1);
        indx(j)=pos;
        a=pinv(D(:,indx(1:j)))*x;
        residual=x-D(:,indx(1:j))*a;
        apperr(j,k) = norm(residual);%/normx;
        if apperr(j,k) < 1e-3*normx
            apperr(j:L,k) = apperr(j,k);
            break;
        end
    end;
end;
return;
