function rdicos = aligndico(rdico,dico)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% reorders and signflips a (recovered) dictionary 
% to align with another (generating) dictionary
%   Input :
%       -rdico      ... recovered dictionary
%       -dico       ... generating dictionary
%   Output:
%       -rdicos   ... the reordered dictionary
%
% (c) 14.09.17 Karin Schnass
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[d,K]=size(rdico);
closest=zeros(1,K);

for k=1:K
    [~,ind] = max(abs(dico'*rdico(:,k)));
    closest(k) = ind(1);
    rdico(:,k) = sign(dico(:,closest(k))'*rdico(:,k))*rdico(:,k);
end
[~, ind]=sort(closest);
rdicos=rdico(:,ind);


